# See /usr/share/postfix/main.cf.dist for a commented, more complete version

smtpd_banner = $myhostname ESMTP $mail_name (Debian/GNU)
biff = no

# appending .domain is the MUA's job.
append_dot_mydomain = no

# Uncomment the next line to generate "delayed mail" warnings
#delay_warning_time = 4h

readme_directory = no

# See http://www.postfix.org/COMPATIBILITY_README.html -- default to 2 on
# fresh installs.
compatibility_level = 2

myhostname = {{ mailserver.hostname }}
myorigin = $myhostname
mydestination = {{ mailserver.destinations | join(' ') }}
mynetworks = 127.0.0.0/8 [::ffff:127.0.0.0]/104 [::1]/128
mailbox_size_limit = 0
recipient_delimiter = +
inet_interfaces = {%- for inet in mailserver.interfaces -%}
	{%- set ipv4 = ansible_facts[inet.name]['ipv4'] -%}
	{%- if ipv4 -%}
		{%- if ipv4 is not mapping -%}
			{%- for ip in ipv4 -%}
				{{ ' ' ~ ip['address'] }}
			{%- endfor -%}
		{%- else -%}
			{{ ' ' ~ ipv4['address'] }}
		{%- endif -%}
	{%- endif -%}
	{%- set ipv6 = ansible_facts[inet.name]['ipv6'] -%}
	{%- if ipv6 -%}
		{%- if ipv6 is not mapping -%}
			{%- for ip in ipv6 -%}
				{%- if not ip['address'].startswith('fe80:') %}{{ ' ' ~ ip['address'] }}{% endif -%}
			{%- endfor -%}
		{%- else -%}
			{%- if not ip['address'].startswith('fe80:') %}{{ ' ' ~ ipv6['address'] }}{% endif -%}
		{%- endif -%}
	{%- endif -%}
{%- endfor %}

inet_protocols = all

strict_rfc821_envelopes = yes
mime_header_checks = regexp:/etc/postfix/header_checks
header_checks = regexp:/etc/postfix/header_checks

mailbox_transport = lmtp:unix:private/dovecot-lmtp

# alias_maps = hash:/etc/postfix/aliases
# alias_database = hash:/etc/postfix/aliases
virtual_alias_maps = hash:/etc/postfix/virtual
local_recipient_maps = $virtual_alias_maps

# TLS parameters
#
# See /usr/share/doc/postfix/TLS_README.gz in the postfix-doc package for
# information on enabling SSL in the smtp client.
#

# XXX: Discourse is not in our trusted networks (yet? it's in docker) and doesn't do TLS.
smtpd_tls_auth_only = no

smtpd_tls_security_level = may
smtpd_tls_session_cache_database = btree:${data_directory}/smtpd_scache
smtpd_tls_protocols = !SSLv2, !SSLv3, !TLSv1, !TLSv1.1
smtpd_tls_mandatory_ciphers = high
smtpd_tls_exclude_ciphers = aNULL

smtpd_tls_CAfile = /etc/ssl/certs/ca-certificates.crt
smtpd_tls_cert_file = /etc/letsencrypt/live/{{ mailserver.hostname }}/fullchain.pem
smtpd_tls_key_file = /etc/letsencrypt/live/{{ mailserver.hostname }}/privkey.pem

smtp_tls_session_cache_database = btree:${data_directory}/smtp_scache
smtp_tls_security_level = may
smtp_tls_protocols = !SSLv2, !SSLv3, !TLSv1, !TLSv1.1
smtp_tls_mandatory_ciphers = high
smtp_tls_exclude_ciphers = aNULL
smtp_tls_CAfile = /etc/ssl/certs/ca-certificates.crt


# Restrictions
smtpd_helo_required = yes
smtpd_helo_restrictions =
	reject_invalid_helo_hostname,
	permit

smtpd_client_restrictions = permit

smtpd_sender_login_maps = hash:/etc/postfix/login
smtpd_sender_restrictions =
	reject_non_fqdn_sender,
	reject_unknown_sender_domain,
	reject_sender_login_mismatch,
	# permit_sasl_authenticated,
	permit

smtpd_recipient_restrictions =
	reject_non_fqdn_recipient,
	permit_sasl_authenticated,
	permit_auth_destination,
	reject_unknown_recipient_domain,
	reject

# Authentication
smtpd_sasl_type = dovecot
smtpd_sasl_path = private/auth
smtpd_sasl_auth_enable = yes
smtpd_sasl_security_options = noanonymous
